
package com.android.tools.build.bundletool.commands;

import com.android.bundle.Devices;
import com.android.tools.build.bundletool.device.AdbServer;
import com.android.tools.build.bundletool.model.Aapt2Command;
import com.android.tools.build.bundletool.model.ApkListener;
import com.android.tools.build.bundletool.model.ApkModifier;
import com.android.tools.build.bundletool.model.OptimizationDimension;
import com.android.tools.build.bundletool.model.SigningConfiguration;
import com.google.common.collect.ImmutableSet;
import com.google.common.util.concurrent.ListeningExecutorService;
import java.io.PrintStream;
import java.nio.file.Path;
import java.util.Optional;
import javax.annotation.Generated;

@Generated("com.google.auto.value.processor.AutoValueProcessor")
 final class AutoValue_BuildApksCommand extends BuildApksCommand {

  private final Path bundlePath;
  private final Path outputFile;
  private final boolean overwriteOutput;
  private final ImmutableSet<OptimizationDimension> optimizationDimensions;
  private final Optional<Devices.DeviceSpec> deviceSpec;
  private final boolean generateOnlyForConnectedDevice;
  private final Optional<String> deviceId;
  private final Optional<AdbServer> adbServer;
  private final Optional<Path> adbPath;
  private final BuildApksCommand.ApkBuildMode apkBuildMode;
  private final Optional<Aapt2Command> aapt2Command;
  private final Optional<SigningConfiguration> signingConfiguration;
  private final ListeningExecutorService executorServiceInternal;
  private final boolean executorServiceCreatedByBundleTool;
  private final boolean createApkSetArchive;
  private final Optional<ApkListener> apkListener;
  private final Optional<ApkModifier> apkModifier;
  private final Optional<Integer> firstVariantNumber;
  private final Optional<PrintStream> outputPrintStream;

  private AutoValue_BuildApksCommand(
      Path bundlePath,
      Path outputFile,
      boolean overwriteOutput,
      ImmutableSet<OptimizationDimension> optimizationDimensions,
      Optional<Devices.DeviceSpec> deviceSpec,
      boolean generateOnlyForConnectedDevice,
      Optional<String> deviceId,
      Optional<AdbServer> adbServer,
      Optional<Path> adbPath,
      BuildApksCommand.ApkBuildMode apkBuildMode,
      Optional<Aapt2Command> aapt2Command,
      Optional<SigningConfiguration> signingConfiguration,
      ListeningExecutorService executorServiceInternal,
      boolean executorServiceCreatedByBundleTool,
      boolean createApkSetArchive,
      Optional<ApkListener> apkListener,
      Optional<ApkModifier> apkModifier,
      Optional<Integer> firstVariantNumber,
      Optional<PrintStream> outputPrintStream) {
    this.bundlePath = bundlePath;
    this.outputFile = outputFile;
    this.overwriteOutput = overwriteOutput;
    this.optimizationDimensions = optimizationDimensions;
    this.deviceSpec = deviceSpec;
    this.generateOnlyForConnectedDevice = generateOnlyForConnectedDevice;
    this.deviceId = deviceId;
    this.adbServer = adbServer;
    this.adbPath = adbPath;
    this.apkBuildMode = apkBuildMode;
    this.aapt2Command = aapt2Command;
    this.signingConfiguration = signingConfiguration;
    this.executorServiceInternal = executorServiceInternal;
    this.executorServiceCreatedByBundleTool = executorServiceCreatedByBundleTool;
    this.createApkSetArchive = createApkSetArchive;
    this.apkListener = apkListener;
    this.apkModifier = apkModifier;
    this.firstVariantNumber = firstVariantNumber;
    this.outputPrintStream = outputPrintStream;
  }

  @Override
  public Path getBundlePath() {
    return bundlePath;
  }

  @Override
  public Path getOutputFile() {
    return outputFile;
  }

  @Override
  public boolean getOverwriteOutput() {
    return overwriteOutput;
  }

  @Override
  public ImmutableSet<OptimizationDimension> getOptimizationDimensions() {
    return optimizationDimensions;
  }

  @Override
  public Optional<Devices.DeviceSpec> getDeviceSpec() {
    return deviceSpec;
  }

  @Override
  public boolean getGenerateOnlyForConnectedDevice() {
    return generateOnlyForConnectedDevice;
  }

  @Override
  public Optional<String> getDeviceId() {
    return deviceId;
  }

  @Override
  Optional<AdbServer> getAdbServer() {
    return adbServer;
  }

  @Override
  public Optional<Path> getAdbPath() {
    return adbPath;
  }

  @Override
  public BuildApksCommand.ApkBuildMode getApkBuildMode() {
    return apkBuildMode;
  }

  @Override
  public Optional<Aapt2Command> getAapt2Command() {
    return aapt2Command;
  }

  @Override
  public Optional<SigningConfiguration> getSigningConfiguration() {
    return signingConfiguration;
  }

  @Override
  ListeningExecutorService getExecutorServiceInternal() {
    return executorServiceInternal;
  }

  @Override
  boolean isExecutorServiceCreatedByBundleTool() {
    return executorServiceCreatedByBundleTool;
  }

  @Override
  public boolean getCreateApkSetArchive() {
    return createApkSetArchive;
  }

  @Override
  public Optional<ApkListener> getApkListener() {
    return apkListener;
  }

  @Override
  public Optional<ApkModifier> getApkModifier() {
    return apkModifier;
  }

  @Override
  public Optional<Integer> getFirstVariantNumber() {
    return firstVariantNumber;
  }

  @Override
  public Optional<PrintStream> getOutputPrintStream() {
    return outputPrintStream;
  }

  @Override
  public String toString() {
    return "BuildApksCommand{"
        + "bundlePath=" + bundlePath + ", "
        + "outputFile=" + outputFile + ", "
        + "overwriteOutput=" + overwriteOutput + ", "
        + "optimizationDimensions=" + optimizationDimensions + ", "
        + "deviceSpec=" + deviceSpec + ", "
        + "generateOnlyForConnectedDevice=" + generateOnlyForConnectedDevice + ", "
        + "deviceId=" + deviceId + ", "
        + "adbServer=" + adbServer + ", "
        + "adbPath=" + adbPath + ", "
        + "apkBuildMode=" + apkBuildMode + ", "
        + "aapt2Command=" + aapt2Command + ", "
        + "signingConfiguration=" + signingConfiguration + ", "
        + "executorServiceInternal=" + executorServiceInternal + ", "
        + "executorServiceCreatedByBundleTool=" + executorServiceCreatedByBundleTool + ", "
        + "createApkSetArchive=" + createApkSetArchive + ", "
        + "apkListener=" + apkListener + ", "
        + "apkModifier=" + apkModifier + ", "
        + "firstVariantNumber=" + firstVariantNumber + ", "
        + "outputPrintStream=" + outputPrintStream
        + "}";
  }

  @Override
  public boolean equals(Object o) {
    if (o == this) {
      return true;
    }
    if (o instanceof BuildApksCommand) {
      BuildApksCommand that = (BuildApksCommand) o;
      return (this.bundlePath.equals(that.getBundlePath()))
           && (this.outputFile.equals(that.getOutputFile()))
           && (this.overwriteOutput == that.getOverwriteOutput())
           && (this.optimizationDimensions.equals(that.getOptimizationDimensions()))
           && (this.deviceSpec.equals(that.getDeviceSpec()))
           && (this.generateOnlyForConnectedDevice == that.getGenerateOnlyForConnectedDevice())
           && (this.deviceId.equals(that.getDeviceId()))
           && (this.adbServer.equals(that.getAdbServer()))
           && (this.adbPath.equals(that.getAdbPath()))
           && (this.apkBuildMode.equals(that.getApkBuildMode()))
           && (this.aapt2Command.equals(that.getAapt2Command()))
           && (this.signingConfiguration.equals(that.getSigningConfiguration()))
           && (this.executorServiceInternal.equals(that.getExecutorServiceInternal()))
           && (this.executorServiceCreatedByBundleTool == that.isExecutorServiceCreatedByBundleTool())
           && (this.createApkSetArchive == that.getCreateApkSetArchive())
           && (this.apkListener.equals(that.getApkListener()))
           && (this.apkModifier.equals(that.getApkModifier()))
           && (this.firstVariantNumber.equals(that.getFirstVariantNumber()))
           && (this.outputPrintStream.equals(that.getOutputPrintStream()));
    }
    return false;
  }

  @Override
  public int hashCode() {
    int h = 1;
    h *= 1000003;
    h ^= this.bundlePath.hashCode();
    h *= 1000003;
    h ^= this.outputFile.hashCode();
    h *= 1000003;
    h ^= this.overwriteOutput ? 1231 : 1237;
    h *= 1000003;
    h ^= this.optimizationDimensions.hashCode();
    h *= 1000003;
    h ^= this.deviceSpec.hashCode();
    h *= 1000003;
    h ^= this.generateOnlyForConnectedDevice ? 1231 : 1237;
    h *= 1000003;
    h ^= this.deviceId.hashCode();
    h *= 1000003;
    h ^= this.adbServer.hashCode();
    h *= 1000003;
    h ^= this.adbPath.hashCode();
    h *= 1000003;
    h ^= this.apkBuildMode.hashCode();
    h *= 1000003;
    h ^= this.aapt2Command.hashCode();
    h *= 1000003;
    h ^= this.signingConfiguration.hashCode();
    h *= 1000003;
    h ^= this.executorServiceInternal.hashCode();
    h *= 1000003;
    h ^= this.executorServiceCreatedByBundleTool ? 1231 : 1237;
    h *= 1000003;
    h ^= this.createApkSetArchive ? 1231 : 1237;
    h *= 1000003;
    h ^= this.apkListener.hashCode();
    h *= 1000003;
    h ^= this.apkModifier.hashCode();
    h *= 1000003;
    h ^= this.firstVariantNumber.hashCode();
    h *= 1000003;
    h ^= this.outputPrintStream.hashCode();
    return h;
  }

  static final class Builder extends BuildApksCommand.Builder {
    private Path bundlePath;
    private Path outputFile;
    private Boolean overwriteOutput;
    private ImmutableSet<OptimizationDimension> optimizationDimensions;
    private Optional<Devices.DeviceSpec> deviceSpec = Optional.empty();
    private Boolean generateOnlyForConnectedDevice;
    private Optional<String> deviceId = Optional.empty();
    private Optional<AdbServer> adbServer = Optional.empty();
    private Optional<Path> adbPath = Optional.empty();
    private BuildApksCommand.ApkBuildMode apkBuildMode;
    private Optional<Aapt2Command> aapt2Command = Optional.empty();
    private Optional<SigningConfiguration> signingConfiguration = Optional.empty();
    private ListeningExecutorService executorServiceInternal;
    private Boolean executorServiceCreatedByBundleTool;
    private Boolean createApkSetArchive;
    private Optional<ApkListener> apkListener = Optional.empty();
    private Optional<ApkModifier> apkModifier = Optional.empty();
    private Optional<Integer> firstVariantNumber = Optional.empty();
    private Optional<PrintStream> outputPrintStream = Optional.empty();
    Builder() {
    }
    @Override
    public BuildApksCommand.Builder setBundlePath(Path bundlePath) {
      if (bundlePath == null) {
        throw new NullPointerException("Null bundlePath");
      }
      this.bundlePath = bundlePath;
      return this;
    }
    @Override
    public BuildApksCommand.Builder setOutputFile(Path outputFile) {
      if (outputFile == null) {
        throw new NullPointerException("Null outputFile");
      }
      this.outputFile = outputFile;
      return this;
    }
    @Override
    public BuildApksCommand.Builder setOverwriteOutput(boolean overwriteOutput) {
      this.overwriteOutput = overwriteOutput;
      return this;
    }
    @Override
    public BuildApksCommand.Builder setOptimizationDimensions(ImmutableSet<OptimizationDimension> optimizationDimensions) {
      if (optimizationDimensions == null) {
        throw new NullPointerException("Null optimizationDimensions");
      }
      this.optimizationDimensions = optimizationDimensions;
      return this;
    }
    @Override
    public BuildApksCommand.Builder setDeviceSpec(Devices.DeviceSpec deviceSpec) {
      if (deviceSpec == null) {
        throw new NullPointerException("Null deviceSpec");
      }
      this.deviceSpec = Optional.of(deviceSpec);
      return this;
    }
    @Override
    public BuildApksCommand.Builder setGenerateOnlyForConnectedDevice(boolean generateOnlyForConnectedDevice) {
      this.generateOnlyForConnectedDevice = generateOnlyForConnectedDevice;
      return this;
    }
    @Override
    public BuildApksCommand.Builder setDeviceId(String deviceId) {
      if (deviceId == null) {
        throw new NullPointerException("Null deviceId");
      }
      this.deviceId = Optional.of(deviceId);
      return this;
    }
    @Override
    public BuildApksCommand.Builder setAdbServer(AdbServer adbServer) {
      if (adbServer == null) {
        throw new NullPointerException("Null adbServer");
      }
      this.adbServer = Optional.of(adbServer);
      return this;
    }
    @Override
    public BuildApksCommand.Builder setAdbPath(Path adbPath) {
      if (adbPath == null) {
        throw new NullPointerException("Null adbPath");
      }
      this.adbPath = Optional.of(adbPath);
      return this;
    }
    @Override
    public BuildApksCommand.Builder setApkBuildMode(BuildApksCommand.ApkBuildMode apkBuildMode) {
      if (apkBuildMode == null) {
        throw new NullPointerException("Null apkBuildMode");
      }
      this.apkBuildMode = apkBuildMode;
      return this;
    }
    @Override
    public BuildApksCommand.Builder setAapt2Command(Aapt2Command aapt2Command) {
      if (aapt2Command == null) {
        throw new NullPointerException("Null aapt2Command");
      }
      this.aapt2Command = Optional.of(aapt2Command);
      return this;
    }
    @Override
    public BuildApksCommand.Builder setSigningConfiguration(SigningConfiguration signingConfiguration) {
      if (signingConfiguration == null) {
        throw new NullPointerException("Null signingConfiguration");
      }
      this.signingConfiguration = Optional.of(signingConfiguration);
      return this;
    }
    @Override
    BuildApksCommand.Builder setExecutorServiceInternal(ListeningExecutorService executorServiceInternal) {
      if (executorServiceInternal == null) {
        throw new NullPointerException("Null executorServiceInternal");
      }
      this.executorServiceInternal = executorServiceInternal;
      return this;
    }
    @Override
    Optional<ListeningExecutorService> getExecutorServiceInternal() {
      if (executorServiceInternal == null) {
        return Optional.empty();
      } else {
        return Optional.of(executorServiceInternal);
      }
    }
    @Override
    BuildApksCommand.Builder setExecutorServiceCreatedByBundleTool(boolean executorServiceCreatedByBundleTool) {
      this.executorServiceCreatedByBundleTool = executorServiceCreatedByBundleTool;
      return this;
    }
    @Override
    public BuildApksCommand.Builder setCreateApkSetArchive(boolean createApkSetArchive) {
      this.createApkSetArchive = createApkSetArchive;
      return this;
    }
    @Override
    public BuildApksCommand.Builder setApkListener(ApkListener apkListener) {
      if (apkListener == null) {
        throw new NullPointerException("Null apkListener");
      }
      this.apkListener = Optional.of(apkListener);
      return this;
    }
    @Override
    public BuildApksCommand.Builder setApkModifier(ApkModifier apkModifier) {
      if (apkModifier == null) {
        throw new NullPointerException("Null apkModifier");
      }
      this.apkModifier = Optional.of(apkModifier);
      return this;
    }
    @Override
    public BuildApksCommand.Builder setFirstVariantNumber(int firstVariantNumber) {
      this.firstVariantNumber = Optional.of(firstVariantNumber);
      return this;
    }
    @Override
    public BuildApksCommand.Builder setOutputPrintStream(PrintStream outputPrintStream) {
      if (outputPrintStream == null) {
        throw new NullPointerException("Null outputPrintStream");
      }
      this.outputPrintStream = Optional.of(outputPrintStream);
      return this;
    }
    @Override
    BuildApksCommand autoBuild() {
      String missing = "";
      if (this.bundlePath == null) {
        missing += " bundlePath";
      }
      if (this.outputFile == null) {
        missing += " outputFile";
      }
      if (this.overwriteOutput == null) {
        missing += " overwriteOutput";
      }
      if (this.optimizationDimensions == null) {
        missing += " optimizationDimensions";
      }
      if (this.generateOnlyForConnectedDevice == null) {
        missing += " generateOnlyForConnectedDevice";
      }
      if (this.apkBuildMode == null) {
        missing += " apkBuildMode";
      }
      if (this.executorServiceInternal == null) {
        missing += " executorServiceInternal";
      }
      if (this.executorServiceCreatedByBundleTool == null) {
        missing += " executorServiceCreatedByBundleTool";
      }
      if (this.createApkSetArchive == null) {
        missing += " createApkSetArchive";
      }
      if (!missing.isEmpty()) {
        throw new IllegalStateException("Missing required properties:" + missing);
      }
      return new AutoValue_BuildApksCommand(
          this.bundlePath,
          this.outputFile,
          this.overwriteOutput,
          this.optimizationDimensions,
          this.deviceSpec,
          this.generateOnlyForConnectedDevice,
          this.deviceId,
          this.adbServer,
          this.adbPath,
          this.apkBuildMode,
          this.aapt2Command,
          this.signingConfiguration,
          this.executorServiceInternal,
          this.executorServiceCreatedByBundleTool,
          this.createApkSetArchive,
          this.apkListener,
          this.apkModifier,
          this.firstVariantNumber,
          this.outputPrintStream);
    }
  }

}
