
package com.android.tools.build.bundletool.commands;

import com.android.bundle.Config;
import com.android.tools.build.bundletool.model.BundleMetadata;
import com.google.common.collect.ImmutableList;
import java.nio.file.Path;
import java.util.Optional;
import javax.annotation.Generated;

@Generated("com.google.auto.value.processor.AutoValueProcessor")
 final class AutoValue_BuildBundleCommand extends BuildBundleCommand {

  private final Path outputPath;
  private final ImmutableList<Path> modulesPaths;
  private final Optional<Config.BundleConfig> bundleConfig;
  private final BundleMetadata bundleMetadata;
  private final boolean uncompressedBundle;

  private AutoValue_BuildBundleCommand(
      Path outputPath,
      ImmutableList<Path> modulesPaths,
      Optional<Config.BundleConfig> bundleConfig,
      BundleMetadata bundleMetadata,
      boolean uncompressedBundle) {
    this.outputPath = outputPath;
    this.modulesPaths = modulesPaths;
    this.bundleConfig = bundleConfig;
    this.bundleMetadata = bundleMetadata;
    this.uncompressedBundle = uncompressedBundle;
  }

  @Override
  public Path getOutputPath() {
    return outputPath;
  }

  @Override
  public ImmutableList<Path> getModulesPaths() {
    return modulesPaths;
  }

  @Override
  public Optional<Config.BundleConfig> getBundleConfig() {
    return bundleConfig;
  }

  @Override
  public BundleMetadata getBundleMetadata() {
    return bundleMetadata;
  }

  @Override
  boolean getUncompressedBundle() {
    return uncompressedBundle;
  }

  @Override
  public String toString() {
    return "BuildBundleCommand{"
        + "outputPath=" + outputPath + ", "
        + "modulesPaths=" + modulesPaths + ", "
        + "bundleConfig=" + bundleConfig + ", "
        + "bundleMetadata=" + bundleMetadata + ", "
        + "uncompressedBundle=" + uncompressedBundle
        + "}";
  }

  @Override
  public boolean equals(Object o) {
    if (o == this) {
      return true;
    }
    if (o instanceof BuildBundleCommand) {
      BuildBundleCommand that = (BuildBundleCommand) o;
      return (this.outputPath.equals(that.getOutputPath()))
           && (this.modulesPaths.equals(that.getModulesPaths()))
           && (this.bundleConfig.equals(that.getBundleConfig()))
           && (this.bundleMetadata.equals(that.getBundleMetadata()))
           && (this.uncompressedBundle == that.getUncompressedBundle());
    }
    return false;
  }

  @Override
  public int hashCode() {
    int h = 1;
    h *= 1000003;
    h ^= this.outputPath.hashCode();
    h *= 1000003;
    h ^= this.modulesPaths.hashCode();
    h *= 1000003;
    h ^= this.bundleConfig.hashCode();
    h *= 1000003;
    h ^= this.bundleMetadata.hashCode();
    h *= 1000003;
    h ^= this.uncompressedBundle ? 1231 : 1237;
    return h;
  }

  static final class Builder extends BuildBundleCommand.Builder {
    private Path outputPath;
    private ImmutableList<Path> modulesPaths;
    private Optional<Config.BundleConfig> bundleConfig = Optional.empty();
    private BundleMetadata.Builder bundleMetadataBuilder$;
    private BundleMetadata bundleMetadata;
    private Boolean uncompressedBundle;
    Builder() {
    }
    @Override
    public BuildBundleCommand.Builder setOutputPath(Path outputPath) {
      if (outputPath == null) {
        throw new NullPointerException("Null outputPath");
      }
      this.outputPath = outputPath;
      return this;
    }
    @Override
    public BuildBundleCommand.Builder setModulesPaths(ImmutableList<Path> modulesPaths) {
      if (modulesPaths == null) {
        throw new NullPointerException("Null modulesPaths");
      }
      this.modulesPaths = modulesPaths;
      return this;
    }
    @Override
    public BuildBundleCommand.Builder setBundleConfig(Config.BundleConfig bundleConfig) {
      if (bundleConfig == null) {
        throw new NullPointerException("Null bundleConfig");
      }
      this.bundleConfig = Optional.of(bundleConfig);
      return this;
    }
    @Override
    BundleMetadata.Builder bundleMetadataBuilder() {
      if (bundleMetadataBuilder$ == null) {
        bundleMetadataBuilder$ = BundleMetadata.builder();
      }
      return bundleMetadataBuilder$;
    }
    @Override
    public BuildBundleCommand.Builder setUncompressedBundle(boolean uncompressedBundle) {
      this.uncompressedBundle = uncompressedBundle;
      return this;
    }
    @Override
    public BuildBundleCommand build() {
      if (bundleMetadataBuilder$ != null) {
        this.bundleMetadata = bundleMetadataBuilder$.build();
      } else if (this.bundleMetadata == null) {
        BundleMetadata.Builder bundleMetadata$builder = BundleMetadata.builder();
        this.bundleMetadata = bundleMetadata$builder.build();
      }
      String missing = "";
      if (this.outputPath == null) {
        missing += " outputPath";
      }
      if (this.modulesPaths == null) {
        missing += " modulesPaths";
      }
      if (this.uncompressedBundle == null) {
        missing += " uncompressedBundle";
      }
      if (!missing.isEmpty()) {
        throw new IllegalStateException("Missing required properties:" + missing);
      }
      return new AutoValue_BuildBundleCommand(
          this.outputPath,
          this.modulesPaths,
          this.bundleConfig,
          this.bundleMetadata,
          this.uncompressedBundle);
    }
  }

}
